
#include "minivdd.h"
#include "vkd.h"



#pragma VxD_LOCKED_DATA_SEG
PFN pPrev_VCache_Get_Version; 
  
// Macros for defining Win95 Hook procedures
#define     HOOKPROC            void __declspec( naked )

// These two jumps make up the hook preamble
// These are needed to support Unhook_Device_Service
// The real hook procedure begins after these at "real_entry"
#define     HOOK_PREAMBLE(prev)             \
            _asm    jmp short real_entry    \
            _asm    jmp dword ptr prev      \
            _asm    real_entry:


#define PAGEUP 1
#define PAGEDW 2
#define HOME   3


#define DLGEDIT_UPDATE_DEST 0x80000000  //line editor updates specified dest immed..


typedef struct SEDITTEXT
{
	int x;
	int y;
	int cursorpos;        // position of cursor when open.....
	int linewidth;        //displayed line width in chars
	int maxstringlength;  // max length of string 
	int displayoffset;    //offset to start of string in display window 
    int keyvalue;
	int flags;
    int returnpressed;
	char * internalstring;
	
}SEDITTEXT;
#pragma VxD_LOCKED_DATA_SEG
char lockedpwbuffer[160];
#pragma VxD_LOCKED_DATA_SEG

#pragma VxD_LOCKED_DATA_SEG


SEDITTEXT editxtl1;
SEDITTEXT editxtl2;
SEDITTEXT editxtl3;
SEDITTEXT editxtl4;

SEDITTEXT* edtxts[]=
{
&editxtl1,
&editxtl2,
&editxtl3,
&editxtl4,

};

int seditycursor=0;
int seepw=0;

unsigned char HKtable[]=
{


	0x1e,'a','A',255,
	0x30,'b','B',255,
	0x2e,'c','C',255,
	0x20,'d','D',255,
	0x12,'e','E',255,
	0x21,'f','F',255,
	0x22,'g','G',255,
	0x23,'h','H',255,
	0x17,'i','I',255,
	0x24,'j','J',255,
	0x25,'k','K',255,
	0x26,'l','L',255,
	0x32,'m','M',255,
	0x31,'n','N',255,
	0x18,'o','0',255,
	0x19,'p','P',255,
	0x10,'q','Q',255,
	0x13,'r','R',255,
	0x1f,'s','S',255,
	0x14,'t','T',255,
	0x16,'u','U',255,
	0x2f,'v','V',255,
	0x11,'w','W',255,
	0x2d,'x','X',255,
	0x15,'y','Y',255,
	0x2c,'z','Z',255,   

	0x49,PAGEUP,PAGEUP,255,
	0x51,PAGEDW,PAGEDW,255,
	0x47,HOME,HOME,255,
	0x2,'1','!',255,
	0x3,'2','"',255,
	0x4,'3',(unsigned char)'',255,
	0x5,'4','$',255,
	0x6,'5','%',255,
	0x7,'6','^',255,
	0x8,'7','&',255,
	0x9,'8','*',255,
	0xa,'9','(',255,
	0xb,'0',')',255,
	0xc,'-','_',255,
	0xd,'=','+',255,
	


	0x0C,'-','_',255,
	0x0D,'=','+',255,	 
    0x1a,'[','{',255,    	
    0x1b,']','}',255,
	0x1c,13,13,255,
	0x27,';',':',255,
    0x28,39,'@',255,
	0x29,'`',170,255, //(unsigned char) '',255,
	
	
	0x2b,'#','~',255,


	0x3b,'\\','|',255,  // Actually F1...
	0x3c,'#','~',255,  // Actually F2...

	
	0x33,',' , '<',255,
	0x34,'.','>',255,
	0x35,'/','?',255,

  

	0x4b,8,8,255,
	0x4d,9,9,255,
	0x01,27,27,255,
	0x53,127,127,255,
	0x0e,127,127,255,
	0x0f,10,10,255,
	0x50,10,10,255,
	0x48,11,11,255,

	0x39,32,32,255,




	0x00,0,0,0

};


void DeleteMyChar(	SEDITTEXT * t, char * string,int position)
{
int c;
char *source=string+position;
char *dest=string+position-1;
  
if (!position) return;

  do
    {
	  c=*source++;
	  *(dest++)=c;
    }while (c);
 
  
}




int InsertMyChar(	SEDITTEXT * t,char key,char *text,int position,int max)
{
char c;
int l;
char *source;
char *dest;
char *insert=text+position;
l=strlen(text);
l++;
if (l>=max) return 0;

dest=text+l+1;
source=text+l;

	if (position<l)
		{

			do
			{
				c=*source--;
				*(dest--)=c;
			}
			while (dest>insert);


		}

*insert=key;


 return 1;
}



int editcursorflash=0;

void EditTextLine(SEDITTEXT *t,unsigned char key, int vm) //SDIALOGUE * d)

	
{


	int xp,yp;
	int curx;
	int cury;

	unsigned int realcursor;  // actual postition in text.
	 
	 {

	    xp=t->x;//+d->scrx;//+PRINTXOFFSET;
	    yp=t->y; //+d->scry; //+PRINTYOFFSET
	
	 
	  	 
		   curx=t->cursorpos+t->x;;
		   cury=t->y;
		
  		  realcursor= (t->cursorpos+t->displayoffset);
		

		  _asm mov eax,[cury]
		  _asm mov edx,[curx]
		   VxDCall (VDD_Msg_SetCursPos);

		  switch(key)
		   {
		   case 0:
		      break;

	
		   case PAGEUP:
			   seepw=1;
				break;

		   case PAGEDW:
			   seepw=0;
			   break;


			  

		   case 13:
		   case 27:  
		       t->returnpressed=1;
	
		       break;

		   case 11:
			seditycursor--;
			break;
		
		 
		   case 10:
			seditycursor++;
			break;


		       default:
		        if (!InsertMyChar(t,key,t->internalstring,realcursor,t->maxstringlength-1)) break;

		   case 9:
			    {
			     if (t->cursorpos<(t->linewidth-1)) 
				 {
				  if (realcursor<strlen(t->internalstring) )  
				  t->cursorpos++;
				 }
			     else
			     {
				 
					  if (realcursor<strlen(t->internalstring) )
						 t->displayoffset++;

			     }

			 break;
			}



		    case 127:
			      DeleteMyChar(t,t->internalstring,realcursor);

		    case 8:
			     {
			     if (t->cursorpos) t->cursorpos--;
			     else
			     if (t->displayoffset) t->displayoffset--;
			    break;
			     }	

		}//case
	  
	  }//key



	 


}


unsigned char TransKeyToAscii(unsigned short keyandshift)

{

	unsigned char key=keyandshift&255;
	unsigned char shift=keyandshift>>8;
	int n=0;
	do
	{
	
	if (HKtable[n]==key)
			{
			
				if (shift&MK_Shift)
					return HKtable[n+2];
				
				return HKtable[n+1];
				break;
	
			}
	n=n+4;
	}
	while (HKtable[n]);
	return 0;
}





HOOKPROC MykbFilt( void ) 
{
    HOOK_PREAMBLE(pPrev_VCache_Get_Version)
   

	_asm push ecx
	_asm and ecx,127
	_asm  cmp  cl,2ch
	_asm pop   ecx
    _asm stc
	_asm  jz fil1
    _asm   clc
_asm fil1:
    _asm    ret
    }



void keyhook(void)
{
int  v;

 v=GetVxDServiceOrdinal(VKD_Filter_Keyboard_Input);

_asm mov eax,[v]
_asm mov esi,offset MykbFilt
_asm VxDCall (Hook_Device_Service)

//Hook_Device_Service(GetVxDServiceOrdinal(VKD_Filter_Keyboard_Input), MykbFilt );
}
 
#pragma VxD_LOCKED_DATA_SEG



VOID ub2(int id) //OP iop, cryptvol* cv)
{

	_SignalID(id);

}
void __declspec(naked) callkeyunblock(void)
{
_asm pushfd
_asm pushad
_asm push ebp
_asm mov ebp,esp
_asm push edx
_asm call ub2
_asm add esp,4
_asm pop ebp
_asm popad
_asm popfd
_asm cld
_asm sti
_asm ret

}


char Msgspaces[]="                                                                                "; //80 spaces
char pws1[]="1:                                        ";
char pws2[]="2:                                        ";
char pws3[]="3:                                        ";
char pws4[]="4:                                        ";

char ed1[44]={0,0,0,0,0,0,0,0};
char ed2[44]={0,0,0,0,0,0,0,0};
char ed3[44]={0,0,0,0,0,0,0,0};
char ed4[44]={0,0,0,0,0,0,0,0};

char mystring[]=" ";

void MsgString(char *string,int x,int y,int fore,int back,int vm)
{
	int n;
	_asm mov eax,[back]
	_asm mov ebx,[vm]
	 VxDCall (VDD_Msg_BakColor);
	
	_asm mov eax,[fore]
	_asm mov ebx,[vm]
	VxDCall (VDD_Msg_ForColor);

	n=strlen(string);
	if (n==0) return;

	_asm mov esi,[string]
	_asm mov ecx,[n]
	_asm mov eax,[y]
	_asm mov edx,[x]
	_asm mov ebx,[vm]
	VxDCall (VDD_Msg_TextOut);

}

void PWMsgString(char *string,int x,int y,int fore,int back,int vm)
{

char starbuffer[84];
int l;
	if (seepw)
		{
			MsgString(string,x,y,fore,back,vm);
			return;
		}

	l=strlen(string);
	 if ((l) && (l<80) )
	{
	memset (starbuffer,0,80);
	memset (starbuffer,'*',l);
	MsgString(starbuffer,x,y,fore,back,vm);
	}

}


void SpinTasks(void)  //block caller....
{
	 void (*me)(void)=&callkeyunblock;
	Schedule_Global_Event(me,(ULONG) &mystring);
	_BlockOnID((ULONG) &mystring,BLOCK_ENABLE_INTS|BLOCK_SVC_INTS);
}



unsigned char key(int vm)
{

   
  void (*me)(void)=&callkeyunblock;
  
    unsigned short  keyval=0;
	unsigned char keyback;

	Schedule_Global_Event(me,(ULONG) &mystring);
	_BlockOnID((ULONG) &mystring,BLOCK_ENABLE_INTS|BLOCK_SVC_INTS);

	_asm xor eax,eax
	_asm mov ebx,[vm]
	VxDCall (VKD_Peek_Msg_Key);
	_asm	jz outnone ;//keyloop
	_asm mov ebx,[vm]
	VxDCall (VKD_Get_Msg_Key);
	_asm jmp short keyout
	
	_asm outnone:
	_asm xor eax,eax
	_asm keyout:

	_asm and al,127 ; //just in case...


	_asm mov [keyval],ax
	
	
	keyback=0;
	if (keyval&255) 
			keyback=TransKeyToAscii(keyval);
	return keyback;
}

//void 	VXDINLINE GetPasswordsDosStyle(char *caption) 
int 	VXDINLINE GetPasswordsDosStyle(char *caption) 
	
{
  int vm;
  int c;
  int cx,cl;
  int pwx=20;
  int pwy=10;
  int accepted=0;
 
  unsigned char keyval;
  void (*me)(void)=&callkeyunblock;

   
  seditycursor=0;

 // seepw=0;

  
  vm=Get_Cur_VM_Handle();
  

  cl=(strlen(caption)/2);
  cx=40-cl;
  

  memcpy(ed1,(char *) &lockedpwbuffer[0],40);
  ed1[40]=0;

  memcpy(ed2,(char *) &lockedpwbuffer[40],40);
  ed2[40]=0;

 memcpy(ed3,(char *) &lockedpwbuffer[80],40);
  ed3[40]=0;
 
  memcpy(ed4,(char *) &lockedpwbuffer[120],40);
 ed4[40]=0;

	_asm pushad
	_asm pushfd
   
	_asm mov ebx,[vm]
	_asm mov eax,BEGIN_MESSAGE_MODE
	VxDCall(System_Control);


	_asm mov ebx,[vm]
	_asm VxDCall(VDD_Msg_ClrScrn)

	for (c=0;c<24;c++)
	MsgString(Msgspaces,0,c,7,4,vm); 
	
	MsgString(caption,cx,2,7,4,vm); 

	
	_asm pushfd
	

	MsgString(pws1,pwx,pwy,7,1,vm); 
	MsgString(pws2,pwx,pwy+2,7,1,vm); 
	MsgString(pws3,pwx,pwy+4,7,1,vm); 
	MsgString(pws4,pwx,pwy+6,7,1,vm); 
	MsgString("ESCAPE=Cancel ENTER=Accept,TAB=Next HOME=Clear ",20,21,7,4,vm); 
	MsgString("PAGEUP=visible  PAGEDOWN=hide  F1= | \\ F2=# ~",20,22,7,4,vm);
	editxtl1.x=pwx+2;
	editxtl1.y=pwy;
	editxtl1.internalstring=ed1;
	editxtl1.cursorpos=strlen(ed1);        // position of cursor when open.....
	editxtl1.linewidth=42-1;        //displayed line width in chars
	editxtl1.maxstringlength=42-1;  // max length of string 
	editxtl1.displayoffset=0;     // handles longer strings..



	editxtl2.x=pwx+2;
	editxtl2.y=pwy+2;
	editxtl2.internalstring=ed2;
	editxtl2.cursorpos=strlen(ed2);        // position of cursor when open.....
	editxtl2.linewidth=42-1;        //displayed line width in chars
	editxtl2.maxstringlength=42-1;  // max length of string 
	editxtl2.displayoffset=0;     // handles longer strings..


	editxtl3.x=pwx+2;
	editxtl3.y=pwy+4;
	editxtl3.internalstring=ed3;
	editxtl3.cursorpos=strlen(ed3);        // position of cursor when open.....
	editxtl3.linewidth=42-1;        //displayed line width in chars
	editxtl3.maxstringlength=42-1;  // max length of string 
	editxtl3.displayoffset=0;     // handles longer strings..

	editxtl4.x=pwx+2;
	editxtl4.y=pwy+6;
	editxtl4.internalstring=ed4; //(char *) &pws4[2];
	editxtl4.cursorpos=strlen(ed4);        // position of cursor when open.....
	editxtl4.linewidth=42-1;        //displayed line width in chars
	editxtl4.maxstringlength=42-1;  // max length of string 
	editxtl4.displayoffset=0;     // handles longer strings..

	do
	{
	keyval=key(vm);	
	 EditTextLine(edtxts[seditycursor&3],keyval,vm);

	 if (keyval==HOME)
		{
		seditycursor=0;
		memset(ed1,0,41);
		memset(ed2,0,41);
		memset(ed3,0,41);
		memset(ed4,0,41);
		editxtl1.cursorpos=0;
		editxtl2.cursorpos=0;
		editxtl3.cursorpos=0;
		editxtl4.cursorpos=0;
		}


	if (keyval)
		{
		MsgString(pws1,pwx,pwy,7,1,vm); 
		MsgString(pws2,pwx,pwy+2,7,1,vm); 
		MsgString(pws3,pwx,pwy+4,7,1,vm); 
		MsgString(pws4,pwx,pwy+6,7,1,vm); 
		}

	  PWMsgString(ed1,pwx+2,pwy,7,1,vm); 
	  PWMsgString(ed2,pwx+2,pwy+2,7,1,vm); 
	  PWMsgString(ed3,pwx+2,pwy+4,7,1,vm); 
	  PWMsgString(ed4,pwx+2,pwy+6,7,1,vm); 

	
	}while ( (keyval!=27) && (keyval!=13));

	accepted = 0;

	if (keyval==13)
	{
		memcpy((char *) &lockedpwbuffer[0],ed1,40);
		memcpy((char *) &lockedpwbuffer[40],ed2,40);
		memcpy((char *) &lockedpwbuffer[80],ed3,40);
		memcpy((char *) &lockedpwbuffer[120],ed4,40);
		accepted=1;

	}

	_asm popfd
	_asm mov ebx,[vm]
	_asm mov eax,END_MESSAGE_MODE
	VxDCall(System_Control);

	_asm popfd
	_asm popad

	return accepted;
}


void 	VXDINLINE EndMessageMode(void) 
{
	_asm pushfd
	_asm pushad
    Get_Cur_VM_Handle();
	_asm mov ebx,eax
    _asm mov eax,END_MESSAGE_MODE
    VxDCall(System_Control);
	_asm popad
	_asm popfd
}



	
//***********

void keyh(void)
{


}




void InstallHotKeys(char * table) {
    _asm {
        pushfd
		pushad
		mov ebx,[table]

		
keyloop:
		mov     al,[ebx] ;48h                          // Hot key: Up
   		or al,al
		jz klend
		push ebx
		mov     ah,0
        mov     ebx,0; //-1  ;HKSS_Alt                    // either ALT key
        mov     esi, offset keyh; //LineUpHandler       // address of our handler
        mov     cl, CallOnPress OR Local_Key    // call when hot key is released
        mov     edx,1                          // reference data - arbitrary
        xor     edi,edi                         // 
		
		VxDCall( VKD_Define_Hot_Key );
		pop ebx
		add ebx,4
		jmp keyloop
klend:  popad
		popfd


	}

}
//**************8





